// this program needs the following modifications
//     1. inheritance / add another type of animal
//     2. exception handling
//     3. add/delete racer keyboard interfaces


#include "Animal.h"
#include "Race.h"
#include <iostream.h> // cout

int main(void)
{
    Race race(5, 6, 10, 70); // orgX, orgY, maxRacer, trackLength

    int initX=5, initY=2; // initial rest area
    Animal turtle1("t1", initX+=3,  initY, 0,  1, 0, 99); // symbol, initX, initY, 
    Animal turtle2("t2", initX+=3,  initY, 0,  2, 0, 99); //      maxTimeToSleep, stepSize,
    Animal rabbit1("r1", initX+=3,  initY, 12, 3, 2, 5);  //      maxWatchedRacer, aheadSteps
    Animal rabbit2("r2", initX+=3,  initY, 24, 4, 3, 6); 
    Animal rabbit3("r3", initX+=3,  initY, 8,  3, 3, 3); 

    if (!rabbit1.addToWatchList(turtle1) ||
        !rabbit1.addToWatchList(turtle2) )
    {
        cout << "Rabbit1 can remember " << rabbit1.numberOfWatchedRacers()
             << "only." << endl;
        cout << "Rabbit1 internal error." << endl;
        return 1;
    }
    
    if (!rabbit2.addToWatchList(turtle1) ||
        !rabbit2.addToWatchList(turtle2) ||
        !rabbit2.addToWatchList(rabbit1) )
    {
        cout << "Rabbit2 can remember " << rabbit2.numberOfWatchedRacers()
             << "only." << endl;
        cout << "Rabbit2 internal error." << endl;
        return 1;
    }

    if (!rabbit3.addToWatchList(turtle2) ||
        !rabbit3.addToWatchList(rabbit1) )
    {
        cout << "Rabbit3 can remember " << rabbit3.numberOfWatchedRacers()
             << "only." << endl;
        cout << "Rabbit3 internal error." << endl;
        return 1;
    }

    if (!race.addRacer(rabbit1) ||
        !race.addRacer(rabbit2) ||
        !race.addRacer(turtle1) ||
        !race.addRacer(turtle2) ||
        !race.addRacer(rabbit3) )
    {
        cout << "This race can not hold more than " << race.numberOfRacers()
             << " racers" << endl;
        cout << "Race can not start" << endl;
        return 1;
    }

    race.go();

    race.reportResult();
    return 0;
}